#include <stdio.h>
#include <stdlib.h>
#include "ler_escrever.h"
#include "grelha.h"

NoGrelha *primeiro[7];
NoGrelha *ultimo[7];

void inicializar_prog_grelha() {
  int i;

  for (i=0;i<7;i++) {
    primeiro[i] = NULL;
    ultimo[i] = NULL;
  }
}

int adic_prog_grelha_fim(int prog, int dia, int max) {
  NoGrelha *ngptr;
  int prox_horario = INICIO_HORARIO_NOBRE;
  
  if (ultimo[dia] != NULL)
    prox_horario = ultimo[dia]->fim;
  if (prox_horario > max) return 0;  //esgotou os slots disponíveis
  else {
    ngptr = (NoGrelha*) malloc(sizeof(NoGrelha));
    ngptr->idx_programa = prog;
    ngptr->inicio = prox_horario;
    ngptr->fim = prox_horario + programas[prog].duracao;
    ngptr->prev = ultimo[dia];
    ngptr->next = NULL;
    if (primeiro[dia] == NULL) primeiro[dia] = ngptr;
    if (ultimo[dia] != NULL) ultimo[dia]->next = ngptr;
    ultimo[dia] = ngptr;
    return 1;
  }
}

int adic_prog_grelha_inicio(int prog, int dia) {
  NoGrelha *ngptr;
  int prox_horario = INICIO_HORARIO_NOBRE - programas[prog].duracao;
  
  if (primeiro[dia] != NULL)
    prox_horario = primeiro[dia]->inicio - programas[prog].duracao;
  if (prox_horario < 0) return 0;  //esgotou os slots disponíveis
  else {
    ngptr = (NoGrelha*) malloc(sizeof(NoGrelha));
    ngptr->idx_programa = prog;
    ngptr->inicio = prox_horario;
    ngptr->fim = primeiro[dia]->inicio;
    ngptr->prev = NULL;
    ngptr->next = primeiro[dia];
    if (ultimo[dia] == NULL) ultimo[dia] = ngptr;
    if (primeiro[dia] != NULL) primeiro[dia]->prev = ngptr;
    primeiro[dia] = ngptr;
    return 1;
  }
}

int construir_grelha() {
  int i, j;

  inicializar_prog_grelha();

  //1º escalonar programas de alta audiência diários
  for (j=0; j<n_programas; j++) {
    if (programas[j].audiencia=='A' && programas[j].period=='D') {
      for (i=0; i<7; i++)
        if (!adic_prog_grelha_fim(j,i,FIM_HORARIO_NOBRE)) return 0;
    }
  }

  //2º escalonar programas de alta audiência semanais
  for (j=0; j<n_programas; j++) {
    if (programas[j].audiencia=='A' && programas[j].period=='S') {
      i=0;
      while (i<7 && !adic_prog_grelha_fim(j,i,FIM_HORARIO_NOBRE)) i++;
      if (i==7) return 0;
    }
  }

  //3º escalonar programas de baixa audiência diários
  for (j=0; j<n_programas; j++) {
    if (programas[j].audiencia=='B' && programas[j].period=='D') {
      for (i=0; i<7; i++)
        if (!adic_prog_grelha_inicio(j,i)) return 0;
    }
  }

  //4º escalonar programas de baixa audiência semanais
  for (j=0; j<n_programas; j++) {
    if (programas[j].audiencia=='B' && programas[j].period=='S') {
      i=0;
      while (i<7 && !adic_prog_grelha_fim(j,i,24*60)) i++;
      if (i==7) {
          i=0;
          while (i<7 && !adic_prog_grelha_inicio(j,i)) i++;
	  if (i==7) return 0;
      }
    }
  }

  return 1;
}